<template>
    <div>
        <div class="upload">
            <h1>Send file</h1>
            <label for="file">Select file:</label>
            <input type="file" class="btn" ref="model3d" id="model3d" name="model3d" @change="handleFile()">
            <input type="submit" class="btn" @click="onImport($event)">
        </div>

        <div class="msg" v-bind:class="[ type ]" v-if="msg">{{ msg }}</div>

        <div class="grid">
            <div class="quarter" v-for="item in uploaded">
                <div class="quarter-content">
                    <img class="img-thumbnail" style="height: 150px; width: 100%; display: block;" :src="item.path_thumbnail">
                    {{ item.name }} <button class="btn red" @click="onDestroy(item.id)">Delete</button><button class="btn green" @click="onEdit(item.id)">Edit</button>
                </div>
            </div>
        </div>

        <div class="upload" v-if="id">
            <h1>Update file</h1>
            <label for="file">Select file:</label>
            <input type="file" class="btn" ref="model3d" id="model3d" name="model3d" @change="handleFile()">
            <input type="submit" class="btn" @click="onUpdate($event, id)">
        </div>
    </div>
</template>

<script>
export default {
    data () {
       return {
          id: '',
          model3d: '',
          uploaded: [],
          msg: '',
          type:''
        }
    },
    mounted() {
        this.getData();
    },
    methods: {
        handleFile() {
            this.model3d = this.$refs.model3d.files[0];
        },
        onImport(e)
        {
            e.preventDefault();
            let formData = new FormData();
            formData.append('file', this.model3d);
            axios.post( '/api/file/import',
              formData,
              {
                headers: {
                    'Content-Type': 'multipart/form-data'
                }
              }
            ).then((response) => {
                this.msg = response.data.msg;
                this.type = response.data.type;
                this.getData();
            })
            .catch((errors) => {
                this.msg = errors.response.data.message;
                this.type = 'danger';
            });
        },
        onEdit(id)
        {
            this.id = id;
        },
        onUpdate(e, id)
        {
            e.preventDefault();
            let formData = new FormData();
            formData.append('file', this.model3d);
            formData.append('_method', 'PATCH');
            axios.post( '/api/file/update/'+id,
              formData,
              {
                headers: {
                    'Content-Type': 'multipart/form-data'
                }
              }
            ).then((response) => {
                this.msg = response.data.msg;
                this.type = response.data.type;
                this.getData();
            })
            .catch((errors) => {
                this.msg = errors.response.data.message;
                this.type = 'danger';
            });
        },
        onDestroy(id)
        {
            axios.post( '/api/file/destroy/'+id, { _method: "DELETE"}).then((response) => {
                this.msg = response.data.msg;
                this.type = response.data.type;
                this.id = null;
                this.getData();
            })
            .catch(function(errors) {
            });
        },
        getData(e)
        {
            axios.get( '/api/file').then((response) => {
                this.uploaded = response.data;
            })
            .catch(function(errors) {
            });
        },
    },
 }
 </script>
